/*
 * Memory quantity calculation utilities.
 *
 * Copyright (C) 2021 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <systypes/base.h>

#define PAGE_SIZE 4096



/* Address arithmetic. */

offset_t page(unsigned int n);

unsigned int page_order(offset_t size);

offset_t round(offset_t value, offset_t increment);

offset_t round_multiple(offset_t value, offset_t increment);

offset_t trunc(offset_t value, offset_t increment);

offset_t trunc_multiple(offset_t value, offset_t increment);

offset_t max_multiple(offset_t start, offset_t end, offset_t increment);

// vim: tabstop=4 expandtab shiftwidth=4
